Option Explicit On
'Imports GDO = Intergraph.GeoMedia.GDO
Imports vPView = Intergraph.GeoMedia.PView
Imports vPClient = Intergraph.GeoMedia.PClient
Imports vGMMapv = Intergraph.GeoMedia.MapviewLib.GMMapView
Imports vGSS = Intergraph.GeoMedia.PCSS
Imports vPpipe = Intergraph.GeoMedia.PPipe
Imports vMeta = Intergraph.GeoMedia.GMService
Imports vPservice = Intergraph.GeoMedia.PService

Public Class frmCHARTSDATA
    Public Structure ResultatsPartits
        Dim Partit As String
        Dim Anyo As Integer
        Dim Cens As Long
        Dim Votans As Long
        Dim Vots As Long
    End Structure
    Public Const GRAFIC_BARRES As String = "Barres"
    Public Const GRAFIC_SECTORS As String = "Sectors"
    Public Const GRAFIC_LINIES As String = "Linies"
    Dim vStrPathFile As String
    Dim GeomDig As vPClient.GeometryDigitizeService
    Dim objstyleService As New vPView.StyleService
    Dim objGeomEdit As New vPClient.GeometryEditService
    Dim objStyle As vPView.StyleDefinition
    Dim objStyle1 As vPView.StyleDefinition
    Dim objGeomOut As Object
    Dim IsDig As Boolean, isLine As Boolean
    Private Sub frmCHARTSDATA_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        On Error GoTo Error_Load
        Dim vConn As vPClient.Connection
        Dim vDB As GDO.GDatabase, strSQL As String
        Dim vRS As GDO.GRecordset
        Dim i As Integer
        '========================================
        vConn = gobjGeoApp.Document.Connections(1)
        vDB = vConn.Database
        If Me.cmbComarca.Items.Count = 0 Then
            strSQL = "SELECT C.NOM_COMAR FROM COMARQUES AS C ORDER BY C.COMARCA;"
            vRS = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
            'Omplim el primer combo.
            If Not vRS.EOF And Not vRS.BOF Then
                vRS.MoveLast() : vRS.MoveFirst()
                For i = 0 To vRS.RecordCount - 1
                    Me.cmbComarca.Items.Add(vRS.GFields(0).Value)
                    vRS.MoveNext()
                Next
            End If
        End If
        If Me.cmbPartit.Items.Count = 0 Then
            strSQL = "SELECT DISTINCT P.NOM FROM partits AS P ORDER BY P.NOM;"
            vRS = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
            'Omplim el primer combo.
            If Not vRS.EOF And Not vRS.BOF Then
                vRS.MoveLast() : vRS.MoveFirst()
                For i = 0 To vRS.RecordCount - 1
                    Me.cmbPartit.Items.Add(vRS.GFields(0).Value)
                    vRS.MoveNext()
                Next
            End If
        End If
        If Me.cmbConvocatoria1.Items.Count = 0 Then
            strSQL = "SELECT DISTINCT P.ANYO FROM PARTICIPACIO AS P ORDER BY P.ANYO;"
            vRS = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
            If Not vRS.EOF And Not vRS.BOF Then
                vRS.MoveLast() : vRS.MoveFirst()
                For i = 0 To vRS.RecordCount - 1
                    Me.cmbConvocatoria1.Items.Add(vRS.GFields("ANYO").Value)
                    Me.cmbConvocatoria2.Items.Add(vRS.GFields("ANYO").Value)
                    vRS.MoveNext()
                Next
            End If
        End If
        Me.RadioButLinies.Checked = True
        Me.cmbPartit.Text = "TOTS"
        If Me.RadioButLinies.Checked = True Then
            Me.cmbConvocatoria2.Enabled = True
            'Me.cmbConvocatoria2.Items(0).ToString()
        Else
            Me.cmbConvocatoria2.Enabled = False
        End If

Load_Exit:
        i = Nothing
        vRS = Nothing
        vDB = Nothing : strSQL = Nothing
        vConn = Nothing
        Exit Sub

Error_Load:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Carregar el formulari", 64)
        Resume Load_Exit
    End Sub
    'Aquest procediment prepara la construcci de la entitat geomtrica. Desprs la guarda a la BD. Desprs prepara la
    'finalment prepara la publicacio al mapView 
    Private Sub btnDibuixarGrafic_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDibuixarGrafic.Click
        Dim vOpcio As Byte '1=Linies; 2=Sectors; 3=Barres
        On Error GoTo Error_BtnDibuixarGrafic
        'Establit l'opci de grfic escollida
        'Verificar l'estat dels controls
        If Me.cmbComarca.Text = "" Then
            MsgBox("S'ha de seleccionar una comarca", MsgBoxStyle.Information, "Informaci al usuari")
            Me.cmbComarca.Focus()
            GoTo BtnDibuixarGrafic_Exit
        ElseIf Me.cmbConvocatoria1.Text = "" Then
            MsgBox("S'ha de seleccionar la 1a" & vbCrLf & _
            "convocatria per a fer el grfic", MsgBoxStyle.Information, "Informaci al usuari")
            Me.cmbConvocatoria1.Focus()
            GoTo BtnDibuixarGrafic_Exit
        ElseIf Me.cmbPartit.Text = "" Then
            MsgBox("S'ha de seleccionar un partit" & vbCrLf & _
            "per a fer el grfic", MsgBoxStyle.Information, "Informaci al usuari")
            Me.cmbPartit.Focus()
            GoTo BtnDibuixarGrafic_Exit
        End If
        If Me.RadioButLinies.Checked = True Then
            vOpcio = 1
        ElseIf Me.RadioButSectors.Checked = True Then
            vOpcio = 2
        ElseIf Me.RadioButBarres.Checked = True Then
            vOpcio = 3
        End If
        If vOpcio = 1 Then 'Grfic de linies
            If Me.cmbConvocatoria2.Text = "" Then
                MsgBox("S'ha de seleccionar tamb la 2a" & vbCrLf & _
                       "convocatria per a fer el grfic.", MsgBoxStyle.Information, "Informaci al usuari")
                Me.cmbConvocatoria2.Focus()
                GoTo BtnDibuixarGrafic_Exit
            ElseIf Val(Trim(Me.cmbConvocatoria2.Text)) <= Val(Trim(Me.cmbConvocatoria1.Text)) Then
                MsgBox("La segona convocatria ha de ser posterior" & vbCrLf & _
                       "a la primera convocatria.", MsgBoxStyle.Information, "Informaci al usuari")
                Me.cmbConvocatoria1.Focus()
                GoTo BtnDibuixarGrafic_Exit
            End If
        End If
        'Eliminar llegendes sobreres
        Dim vGralFunctions As New GeneralFuncions
        If vGralFunctions.Clean_Legend_Entries() = False Then
            GoTo BtnDibuixarGrafic_Exit
        End If
        'Eliminar dades de la Base de dades
        removeTableData()
        'LLencem la construcci del grfic
        Select Case vOpcio
            Case 1 'Grfic de linies
                dibuixarGraficLinies()
            Case 2 'Grfic de sectors
                dibuixarGraficSectors()
            Case 3 'Grfic de Barres
                dibuixarGraficBarres()
        End Select
        'presentar la comarca i la geometria escollida
        showComarcaAndGraphic(Me.cmbComarca.Text)


BtnDibuixarGrafic_Exit:
        Exit Sub
Error_BtnDibuixarGrafic:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Dibuixar grfic", 64)
        'Resume Next
        Resume BtnDibuixarGrafic_Exit
    End Sub

    'Aquest procediment reparteix la feina per enllestir el grfic de linies. El grfic es construeix per apartats
    'En primer lloc el marc general i les seves linies. Desprs les etiquetes del grfic. Ms endavant les linies de
    'cada partit i finalment les etiquetes de cada partit. Les geometries es construeixen primer en funci del lloc
    'd'origen, desprs es guarden a la BD. Finalment es prepara la presentaci en el Map View: crean els estils 
    'adequats per a cada entitat generant la llegenda i, finalment, prepara la publicacio al mapView.
    Private Sub dibuixarGraficLinies()
        On Error GoTo Error_DibuixarGrafic
        'Dimensionament de variables
        '=========================================================
        Dim vConn As vPClient.Connection
        Dim vDB As GDO.GDatabase
        Dim vComarcaPipe As vPClient.OriginatingPipe
        Dim vRS1 As GDO.GRecordset, vRS2 As GDO.GRecordset
        Dim vMV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim GSS As vPClient.GeometryStorageService
        Dim vPunt As New PBasic.point
        Dim vGeneralFunc = New GeneralFuncions
        Dim vGraficFunc = New GraphicFunctions
        Dim vResultats() As ResultatsPartits
        Dim vObj As Object, vOrigen As Object
        Dim strSQL As String, vComarca As String, vPartit As Long, i As Integer, j As Integer
        Dim strError As String
        Dim vEscala As Double, vX As Double, vY As Double, vZ As Double
        Dim vXOrigen As Double, vYOrigen As Double, vMaxX As Double, vMaxY As Double
        Dim IsGraphicCorrect As Boolean
        '=========================================================
        'Tarea:Evaluar les condicions per engegar el procs de construcci dels grfics.
        'Verificar els valors dels combos de selecci.
        '=========================================================
        'Actualitzem el valor de l'escala
        vMV = gobjGeoApp.ActiveWindow.Mapview
        'vMV.Fit()
        'vMV.Refresh()
        vEscala = vMV.DisplayScale
        'Preparem la crida de creaci del objecte
        vConn = gobjGeoApp.Document.Connections(1)
        vDB = vConn.Database
        'Primer omplint les dades de participaci
        '=========================================================
        'Tarea:Preparar el programa per a calcular resultats de 1, tots o varis partits
        '=========================================================
        vComarca = vGeneralFunc.DLookup("[COMARCA]", "COMARQUES", "D.[NOM_COMAR]=""" & Me.cmbComarca.Text & """")
        strSQL = "SELECT DISTINCT P.ANYO, P.CENS_ELECTORAL, P.VOTANTS"
        strSQL = strSQL & " FROM PARTICIPACIO AS P WHERE P.CODI_COMARCA = '" & vComarca & "' AND P.ANYO>="
        strSQL = strSQL & Val(Me.cmbConvocatoria1.Text) & " AND P.ANYO <=" & Val(Me.cmbConvocatoria2.Text) & " ORDER BY P.ANYO;"
        'Crea recordset de participacio
        vRS1 = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
        If Not vRS1.BOF And Not vRS1.EOF Then
            vRS1.MoveLast() : vRS1.MoveFirst()
            ReDim vResultats(vRS1.RecordCount)
            For i = 0 To vRS1.RecordCount - 1
                vResultats(i).Anyo = vRS1.GFields("ANYO").Value
                vResultats(i).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                vResultats(i).Votans = vRS1.GFields("VOTANTS").Value
                vResultats(i).Partit = Me.cmbPartit.Text
                If Me.cmbPartit.Text <> "TOTS" Then
                    vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='" & Me.cmbPartit.Text & "'")
                    vResultats(i).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND [CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                Else
                    vPartit = 0
                    vResultats(i).Vots = 0
                End If
                vRS1.MoveNext()
            Next
        Else
            MsgBox("No existeixen dades per la sollicitut")
            GoTo DibuixarGrafic_Exit
        End If
        'Calculem l'origen del punt del grfic
        '===================================================================
        'Verificar el clcul del punt Origen en relaci amb la geometria de la Comarca.
        '===================================================================
        vConn.CreateOriginatingPipe(vComarcaPipe)
        With vComarcaPipe
            .Table = "Comarques"
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & vComarca & "'"
        End With
        vRS2 = vComarcaPipe.OutputRecordset
        vRS2.MoveLast() : vRS2.MoveFirst()
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vObj = vRS2.GFields("Geometry").Value
        vGraficFunc.calculaPuntoOrigen(vObj, vComarca, vX, vY, vXOrigen, vYOrigen, vMaxX, vMaxY)
        'La geometria que representar el grfic es colloca a la dreta de la comarca.
        'Per aix, en primer lloc establim l'origen del polgon marc.
        vPunt.X = vMaxX + 10 : vPunt.Y = vYOrigen : vPunt.Z = 0.0#
        'Especifiquem el grafic a construir i fem les crides per construir les geometries
        If vGraficFunc.Build_LineChart(vComarca, vPunt, UBound(vResultats)) Then
            If vGraficFunc.Build_TextsOfGrafics(vResultats, vPunt, vComarca, GRAFIC_LINIES) Then
                If Trim(Me.cmbPartit.Text) = "TOTS" Then
                    'Tornem a posar l'origen Y 5000 punts ms amunt
                    vPunt.Y = vPunt.Y + 5000
                    For i = 0 To 5
                        Select Case i
                            Case 0 ' PP
                                vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='PP'")
                                vRS1.MoveFirst()
                                For j = 0 To vRS1.RecordCount - 1
                                    vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                    vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                    vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                    vResultats(j).Partit = "PP"
                                    vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                    vRS1.MoveNext()
                                Next
                            Case 1 ' CIU
                                vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='CIU'")
                                vRS1.MoveFirst()
                                For j = 0 To vRS1.RecordCount - 1
                                    vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                    vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                    vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                    vResultats(j).Partit = "CIU"
                                    vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                    vRS1.MoveNext()
                                Next
                            Case 2 ' ALTRES
                                vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='ALTRES'")
                                vRS1.MoveFirst()
                                For j = 0 To vRS1.RecordCount - 1
                                    vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                    vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                    vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                    vResultats(j).Partit = "ALTRES"
                                    vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                    vRS1.MoveNext()
                                Next
                            Case 3 ' PSC
                                vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='PSC'")
                                vRS1.MoveFirst()
                                For j = 0 To vRS1.RecordCount - 1
                                    vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                    vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                    vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                    vResultats(j).Partit = "PSC"
                                    vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                    vRS1.MoveNext()
                                Next
                            Case 4 ' ERC
                                vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='ERC'")
                                vRS1.MoveFirst()
                                For j = 0 To vRS1.RecordCount - 1
                                    vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                    vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                    vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                    vResultats(j).Partit = "ERC"
                                    vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                    vRS1.MoveNext()
                                Next
                            Case 5 ' IC_V
                                vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='IC_V'")
                                vRS1.MoveFirst()
                                For j = 0 To vRS1.RecordCount - 1
                                    vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                    vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                    vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                    vResultats(j).Partit = "IC_V"
                                    vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                    vRS1.MoveNext()
                                Next
                        End Select
                        IsGraphicCorrect = vGraficFunc.Build_LineOfParties(vResultats, vPunt, vComarca)
                        If IsGraphicCorrect Then
                            IsGraphicCorrect = vGraficFunc.Build_TextsOfParties(vPartit, vPunt, vComarca, GRAFIC_LINIES)
                            If Not IsGraphicCorrect Then
                                strError = "Error Procedent de Procediment de construcci Etiqueta de Partits"
                            End If
                        Else
                            strError = "Error Procedent de Procediment de construcci Linia de dades de Partit"
                        End If
                    Next i
                Else 'Partits per separat
                    vPunt.Y = vPunt.Y + 5000
                    If vGraficFunc.Build_LineOfParties(vResultats, vPunt, vComarca) Then
                        If Not vGraficFunc.Build_TextsOfParties(vPartit, vPunt, vComarca, GRAFIC_LINIES) Then
                            strError = "Error Procedent de Procediment de construcci Etiqueta de Partits"
                        End If
                    Else
                        strError = "Error Procedent de Procediment de construcci Linia de dades de Partit"
                    End If
                End If
            Else
                strError = "Error en Procediment de construcci Etiquetes del grfic"
            End If
        Else
            strError = "Error Procedent de Procediment de construcci Quadre de grfic de Linies"
        End If

DibuixarGrafic_Exit:
        IsGraphicCorrect = Nothing
        vXOrigen = Nothing : vYOrigen = Nothing : vMaxX = Nothing : vMaxY = Nothing
        vEscala = Nothing : vX = Nothing : vY = Nothing : vZ = Nothing
        strSQL = Nothing : vComarca = Nothing : vPartit = Nothing : i = Nothing : j = Nothing
        strError = Nothing
        vObj = Nothing : vOrigen = Nothing
        vResultats = Nothing
        vGraficFunc = Nothing
        vGeneralFunc = Nothing
        vPunt = Nothing
        GSS = Nothing
        vMV = Nothing
        vRS1 = Nothing : vRS2 = Nothing
        vComarcaPipe = Nothing
        vDB = Nothing
        vConn = Nothing
        Exit Sub

Error_DibuixarGrafic:
        'Display the error and get out
        If Not IsGraphicCorrect Then
            MsgBox(strError, 64)
        Else
            MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Dibuixar grfic", 64)
        End If
        'Resume Next
        Resume DibuixarGrafic_Exit
    End Sub

    'Aquest procediment reparteix la feina per enllestir el grfic de linies. El grfic es construeix per apartats
    'En primer lloc el marc general. Desprs crea les etiquetes del grfic. Desprs crea els sectors corresponents
    'a cada partir. Desprs les etiquetes dels partits. Les geometries es construeixen primer en funci del lloc
    'd'origen, desprs es guarden a la BD. Finalment es prepara la presentaci en el Map View: crean els estils 
    'adequats per a cada entitat i finalment generant la llegenda i publicant-ho al mapView
    Private Sub dibuixarGraficSectors()
        On Error GoTo Error_DibuixarGrafic
        'Dimensionament de variables
        '=========================================================
        Dim vConn As vPClient.Connection
        Dim vDB As GDO.GDatabase
        Dim vComarcaPipe As vPClient.OriginatingPipe
        Dim vRS1 As GDO.GRecordset, vRS2 As GDO.GRecordset
        Dim vMV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim GSS As vPClient.GeometryStorageService
        Dim vPunt As New PBasic.point, vPuntPartyLabel As New PBasic.point
        Dim vGeneralFunc = New GeneralFuncions
        Dim vGraficFunc = New GraphicFunctions
        Dim vResultats As ResultatsPartits
        Dim vObj As Object, vOrigen As Object
        Dim strSQL As String, vComarca As String, vPartit As Long, i As Integer, j As Integer
        Dim strError As String
        Dim vEscala As Double
        Dim xPreGran As Double, yPreGran As Double, xPostGran As Double, yPostGran As Double
        Dim xPrePetit As Double, yPrePetit As Double, xPostPetit As Double, yPostPetit As Double
        Dim xRetolSector As Double, yRetolSector As Double
        Dim vX As Double, vY As Double, vZ As Double
        Dim vSumaVots As Long, vSumaVotsMeitat As Double, vAngleAcumulat As Double, vAngleMeitat As Double 'L'angle meitat s per posar-hi el rtol
        Dim vXOrigen As Double, vYOrigen As Double, vMaxX As Double, vMaxY As Double
        '=========================================================
        'Tarea:Evaluar les condicions per engegar el procs de construcci dels grfics.
        'Verificar els valors dels combos de selecci.
        '=========================================================
        'Actualitzem el valor de l'escala
        vMV = gobjGeoApp.ActiveWindow.Mapview
        'vMV.Fit()
        'vMV.Refresh()
        vEscala = vMV.DisplayScale
        'Preparem la crida de creaci del objecte
        vConn = gobjGeoApp.Document.Connections(1)
        vDB = vConn.Database
        'Primer omplint les dades de participaci
        '=========================================================
        'Tarea:Preparar el programa per a calcular resultats de 1, tots o varis partits
        '=========================================================
        vComarca = vGeneralFunc.DLookup("[COMARCA]", "COMARQUES", "D.[NOM_COMAR]=""" & Me.cmbComarca.Text & """")
        strSQL = "SELECT DISTINCT P.ANYO, P.CENS_ELECTORAL, P.VOTANTS"
        strSQL = strSQL & " FROM PARTICIPACIO AS P WHERE P.CODI_COMARCA = '" & vComarca & "' AND P.ANYO="
        strSQL = strSQL & Val(Me.cmbConvocatoria1.Text) & " ORDER BY P.ANYO;"
        'Crea recordset de participacio
        vRS1 = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
        If Not vRS1.BOF And Not vRS1.EOF Then
            vRS1.MoveLast() : vRS1.MoveFirst()
            vResultats.Anyo = vRS1.GFields("ANYO").Value
            vResultats.Cens = vRS1.GFields("CENS_ELECTORAL").Value
            vResultats.Votans = vRS1.GFields("VOTANTS").Value
            vResultats.Partit = Me.cmbPartit.Text
            vPartit = 0
            vResultats.Vots = 0
        Else
            MsgBox("No existeixen dades per la sollicitut")
            GoTo DibuixarGrafic_Exit
        End If
        'Calculem l'origen del punt del grfic
        '===================================================================
        'Verificar el clcul del punt Origen en relaci amb la geometria de la Comarca.
        '===================================================================
        vConn.CreateOriginatingPipe(vComarcaPipe)
        With vComarcaPipe
            .Table = "Comarques"
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & vComarca & "'"
        End With
        vRS2 = vComarcaPipe.OutputRecordset
        vRS2.MoveLast() : vRS2.MoveFirst()
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vObj = vRS2.GFields("Geometry").Value
        vGraficFunc.calculaPuntoOrigen(vObj, vComarca, vX, vY, vXOrigen, vYOrigen, vMaxX, vMaxY)
        'El punt origen pel polgon que emmarca el grfic es abaix a l'esquerra. El polgon es colloca
        'a la dreta de la comarca, tenint com a referncia la coordenada ms baixa de la mateixa.
        'El origen pel grfic de sectors s abaix al mig d'aquest polgon.
        'vPunt constitueix el punt origen pel sector: tant per l'arc com per les linies que el tanquen
        'En primer lloc establim l'origen del polgon marc.
        vPunt.X = vMaxX + 10 : vPunt.Y = vYOrigen - 5000 : vPunt.Z = 0.0#
        'Situem el origen per construir les etiquetes a sota el grfic, per dins el marc
        vPuntPartyLabel.X = vMaxX + 10 : vPuntPartyLabel.Y = vYOrigen : vPuntPartyLabel.Z = 0.0#
        'Especifiquem el grafic a construir
        'Cridem per construir les geometria del polgon
        If vGraficFunc.Build_arcChart(vComarca, vPunt, vResultats.Anyo) Then
            If vGraficFunc.Build_TextsOfArcChart(vPunt, vComarca, vResultats.Anyo, vResultats.Votans) Then
                'If IsGraphicCorrect Then
                'Desprs iniciem la construcci dels sectors representatius dels vots a partir dels segents
                'punts:
                ' - L'origen s a la base del polgon al mig. Tamb s aquest punt l'start de les linies que
                '   uneixen el arc per formar el sector.
                ' - El final de la primera linia i l'inici de la'arc est format per les variables (xPre,yPre)
                ' - el final de la segona linia i el final de l'arc est format per les variables (xPost, yPost)
                '   i es calculen mitjanant les funcions: de la la classe GeneralFunctions
                'El semicercle 180 representa la totalitat dels votants. Els resultats de cada partit s'expressen
                'pel quocient vots/votants. A partir d'aquesta dada es calculen les coordenades a aplicar utilitzant
                'les funcions matematiques sinus i cosinus.
                'El grfic es va muntant d'esquerra a dreta representant una mena de hemicicle.
                vPunt.X = vPunt.X + (AMPLADA_GRAFIC / 2) ' Desplacem la X al centre del polgon
                vPunt.Y = vPunt.Y + 5000 ' Desplacem la Y 10000 unitats a dalt perque el marc envolti tots els elements
                'Coordenades per al radi gran
                xPreGran = vPunt.X - RADI_SECTOR : yPreGran = vPunt.Y 'Al inici tots dos punts valen el mateix
                xPostGran = vPunt.X - RADI_SECTOR : yPostGran = vPunt.Y
                'Coordenades per al radi petit
                xPrePetit = vPunt.X - RADI_SECTOR_PETIT : yPrePetit = vPunt.Y 'Al inici tots dos punts valen el mateix
                xPostPetit = vPunt.X - RADI_SECTOR_PETIT : yPostPetit = vPunt.Y
                vSumaVots = 0
                For i = 1 To 6 'un Sector per cada partit
                    vResultats.Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & i & " AND [ANYO]=" & Val(Me.cmbConvocatoria1.Text))
                    vSumaVotsMeitat = vSumaVots + (vResultats.Vots / 2)
                    vSumaVots = vSumaVots + vResultats.Vots
                    vAngleMeitat = vSumaVotsMeitat / vResultats.Votans
                    vAngleAcumulat = vSumaVots / vResultats.Votans
                    'Pel radi gran
                    xPostGran = vGeneralFunc.getCoordenadaX(vPunt, vAngleAcumulat, 1)
                    yPostGran = vGeneralFunc.getcoordenadaY(vPunt, vAngleAcumulat, 1)
                    'Pel radi petit
                    xPostPetit = vGeneralFunc.getCoordenadaX(vPunt, vAngleAcumulat, 2)
                    yPostPetit = vGeneralFunc.getcoordenadaY(vPunt, vAngleAcumulat, 2)
                    xRetolSector = vGeneralFunc.getcoordenadax(vPunt, vAngleMeitat, 3)
                    yRetolSector = vGeneralFunc.getcoordenadaY(vPunt, vAngleMeitat, 3)
                    Select Case i
                        Case 1 'PP
                            vResultats.Partit = "PP"
                            vPartit = 1
                        Case 2 'CIU
                            vResultats.Partit = "CIU"
                            vPartit = 2
                        Case 3 'ALTRES
                            vResultats.Partit = "ALTRES"
                            vPartit = 3
                        Case 4 'PSC
                            vResultats.Partit = "PSC"
                            vPartit = 4
                        Case 5 'ERC
                            vResultats.Partit = "ERC"
                            vPartit = 5
                        Case 6 'IC_V
                            vResultats.Partit = "IC_V"
                            vPartit = 6
                    End Select
                    If vGraficFunc.Build_ArcOfParties(vComarca, vResultats, vPunt, xPreGran, yPreGran, xPostGran, yPostGran, _
                    xPrePetit, yPrePetit, xPostPetit, yPostPetit) Then
                        xPreGran = xPostGran : yPreGran = yPostGran 'Les coordenades finals del segon punt pasen a ser les primeres del proper
                        xPrePetit = xPostPetit : yPrePetit = yPostPetit 'Les coordenades finals del segon punt pasen a ser les primeres del proper
                        If Not vGraficFunc.Build_TextsOfParties2(vPartit, vPuntPartyLabel, vComarca, GRAFIC_SECTORS, _
                            xRetolSector, yRetolSector, vResultats.Vots / vResultats.Votans) Then
                            strError = "Error Procedent de Procediment de construcci de les Etiquetes dels Partits. Grfic de Sectors"
                            GoTo Error_DibuixarGrafic
                        End If
                    Else
                        strError = "Error Procedent de Procediment de construcci dels Sectors representatius dels Partits."
                        GoTo Error_DibuixarGrafic
                    End If
                Next
            Else
                strError = "Error Procedent de Procediment de construcci del Text del grfic de Sectors"
                GoTo Error_DibuixarGrafic
            End If
        Else
            strError = "Error Procedent de Procediment de construcci Quadre de grfic de Sectors"
            GoTo Error_DibuixarGrafic
        End If

DibuixarGrafic_Exit:
        vXOrigen = Nothing : vYOrigen = Nothing : vMaxX = Nothing : vMaxY = Nothing
        xPreGran = Nothing : yPreGran = Nothing : xPostGran = Nothing : yPostGran = Nothing
        xPrePetit = Nothing : yPrePetit = Nothing : xPostPetit = Nothing : yPostPetit = Nothing
        xRetolSector = Nothing : yRetolSector = Nothing
        vEscala = Nothing : vX = Nothing : vY = Nothing : vZ = Nothing
        vSumaVotsMeitat = Nothing : vSumaVots = Nothing
        vAngleAcumulat = Nothing : vAngleMeitat = Nothing
        strSQL = Nothing : vComarca = Nothing : vPartit = Nothing : i = Nothing : j = Nothing
        strError = Nothing
        vObj = Nothing : vOrigen = Nothing
        vResultats = Nothing
        vGraficFunc = Nothing
        vGeneralFunc = Nothing
        vPunt = Nothing
        GSS = Nothing
        vMV = Nothing
        vRS1 = Nothing : vRS2 = Nothing
        vComarcaPipe = Nothing
        vDB = Nothing
        vConn = Nothing
        Exit Sub

Error_DibuixarGrafic:
        'Display the error and get out
        If strError <> "" Then
            MsgBox(strError, 64)
        Else
            MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Dibuixar grfic", 64)
        End If
        'Resume Next
        Resume DibuixarGrafic_Exit
    End Sub

    'Aquest procediment reparteix la feina per enllestir el grfic de Barres. El grfic es construeix per apartats
    'En primer lloc el marc general i les seves linies. Desprs la etiqueta central del grfic. Ms endavant les barres
    'de cada partit. Desprs els rtols de l'any i %. Finalment les etiquetes de cada partit. Les geometries es construeixen
    'com a polgons mantenint-se la proporcionalitat entre l'altura del polgon i els vots sobre el total.
    'Sempre se segueix el mateix mtode: definir geometria, guardar-la a la BD i presentar-la al mapview, creant l'estil previ.
    Private Sub dibuixarGraficBarres()
        On Error GoTo Error_DibuixarGrafic
        'Dimensionament de variables
        '=========================================================
        Dim vConn As vPClient.Connection
        Dim vDB As GDO.GDatabase
        Dim vComarcaPipe As vPClient.OriginatingPipe
        Dim vRS1 As GDO.GRecordset, vRS2 As GDO.GRecordset
        Dim vMV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim GSS As vPClient.GeometryStorageService
        Dim vPunt As New PBasic.point
        Dim vAnyos() As Integer, vAnyosSelect(1) As Integer
        Dim vGeneralFunc = New GeneralFuncions
        Dim vGraficFunc = New GraphicFunctions
        Dim vResultats() As ResultatsPartits
        Dim vObj As Object, vOrigen As Object
        Dim strSQL As String, vComarca As String, vPartit As Long, i As Integer, j As Integer
        Dim strError As String
        Dim vEscala As Double, vX As Double, vY As Double, vZ As Double
        Dim vXOrigen As Double, vYOrigen As Double, vMaxX As Double, vMaxY As Double
        'Dim IsGraphicCorrect As Boolean
        '=========================================================
        'Tarea:Evaluar les condicions per engegar el procs de construcci dels grfics.
        'Verificar els valors dels combos de selecci.
        '=========================================================
        'Actualitzem el valor de l'escala
        vMV = gobjGeoApp.ActiveWindow.Mapview
        'vMV.Fit()
        'vMV.Refresh()
        vEscala = vMV.DisplayScale
        'Preparem la crida de creaci del objecte
        vConn = gobjGeoApp.Document.Connections(1)
        vDB = vConn.Database
        'Primer omplint les dades de participaci
        '=========================================================
        'Tarea:Preparar el programa per a calcular resultats de 1, tots o varis partits
        '=========================================================
        'Primer de tot omplin la matriu amb els anys de convocatories
        strSQL = "SELECT DISTINCT P.ANYO FROM PARTICIPACIO P ORDER BY P.ANYO;"
        vRS1 = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
        If Not vRS1.BOF And Not vRS1.EOF Then
            vRS1.MoveLast() : vRS1.MoveFirst()
            ReDim vAnyos(vRS1.RecordCount)
            For i = 0 To vRS1.RecordCount - 1
                vAnyos(i) = vRS1.GFields("ANYO").Value
                vRS1.MoveNext()
            Next
        Else
            MsgBox("No se han trobat ejercicis amb dades per processar", MsgBoxStyle.Information)
            GoTo DibuixarGrafic_Exit
        End If
        vComarca = vGeneralFunc.DLookup("[COMARCA]", "COMARQUES", "D.[NOM_COMAR]=""" & Me.cmbComarca.Text & """")
        strSQL = "SELECT DISTINCT P.ANYO, P.CENS_ELECTORAL, P.VOTANTS"
        strSQL = strSQL & " FROM PARTICIPACIO AS P WHERE P.CODI_COMARCA = '" & vComarca & "'"
        Select Case Val(Me.cmbConvocatoria1.Text)
            Case vAnyos(0)
                strSQL = strSQL & " AND P.ANYO=" & vAnyos(0) & " ORDER BY P.ANYO;"
                vAnyosSelect(0) = vAnyos(0)
            Case Else
                For i = 0 To UBound(vAnyos) - 1
                    If vAnyos(i) = Val(Me.cmbConvocatoria1.Text) Then
                        strSQL = strSQL & " AND (P.ANYO=" & vAnyos(i) & " OR P.ANYO=" & vAnyos(i - 1) & ") ORDER BY P.ANYO;"
                        ReDim vAnyosSelect(2)
                        vAnyosSelect(0) = vAnyos(i - 1) : vAnyosSelect(1) = vAnyos(i)
                    End If
                Next
        End Select
        'Crea recordset de participacio
        vRS1 = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
        If Not vRS1.BOF And Not vRS1.EOF Then
            vRS1.MoveLast() : vRS1.MoveFirst()
            ReDim vResultats(vRS1.RecordCount)
            For i = 0 To vRS1.RecordCount - 1
                vResultats(i).Anyo = vRS1.GFields("ANYO").Value
                vResultats(i).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                vResultats(i).Votans = vRS1.GFields("VOTANTS").Value
                vResultats(i).Partit = Me.cmbPartit.Text
                If Me.cmbPartit.Text <> "TOTS" Then
                    vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='" & Me.cmbPartit.Text & "'")
                    vResultats(i).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND [CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                Else
                    vPartit = 0
                    vResultats(i).Vots = 0
                End If
                vRS1.MoveNext()
            Next
        Else
            MsgBox("No existeixen dades per la sollicitut")
            GoTo DibuixarGrafic_Exit
        End If
        'Calculem l'origen del punt del grfic
        '===================================================================
        'Verificar el clcul del punt Origen en relaci amb la geometria de la Comarca.
        '===================================================================
        vConn.CreateOriginatingPipe(vComarcaPipe)
        With vComarcaPipe
            .Table = "Comarques"
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & vComarca & "'"
        End With
        vRS2 = vComarcaPipe.OutputRecordset
        vRS2.MoveLast() : vRS2.MoveFirst()
        GSS = gobjGeoApp.CreateService("GeoMedia.GeometryStorageService")
        vObj = vRS2.GFields("Geometry").Value
        vGraficFunc.calculaPuntoOrigen(vObj, vComarca, vX, vY, vXOrigen, vYOrigen, vMaxX, vMaxY)
        'El punt origen pel polgon que emmarca el grfic es abaix a l'esquerra. El polgon es colloca
        'a la dreta de la comarca, tenint com a referncia la coordenada ms baixa de la mateixa.
        'Per sobre del marc hi ha les etiquetes de partit i ms amunt la base dels polgons
        'vPunt constitueix el punt origen pel sector: tant per l'arc com per les linies que el tanquen
        'En primer lloc establim l'origen del polgon marc.
        vPunt.X = vMaxX + 10 : vPunt.Y = vYOrigen - 5000 : vPunt.Z = 0.0#
        'Especifiquem el grafic a construir
        'Cridem per construir les geometries del grfic
        If vGraficFunc.Build_BARChart(vComarca, vPunt) Then
            'Tornem a reubicar el punt origen per construir les altres geometries
            vPunt.X = vMaxX + 10 : vPunt.Y = vYOrigen : vPunt.Z = 0.0#
            If vGraficFunc.Build_TextsOfGrafics(vResultats, vPunt, vComarca, GRAFIC_BARRES) Then
                For i = 0 To 5
                    Select Case i
                        Case 0 ' PP
                            vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='PP'")
                            vRS1.MoveFirst()
                            For j = 0 To vRS1.RecordCount - 1
                                vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                vResultats(j).Partit = "PP"
                                vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                vRS1.MoveNext()
                            Next
                        Case 1 ' CIU
                            vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='CIU'")
                            vRS1.MoveFirst()
                            For j = 0 To vRS1.RecordCount - 1
                                vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                vResultats(j).Partit = "CIU"
                                vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                vRS1.MoveNext()
                            Next
                        Case 2 ' ALTRES
                            vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='ALTRES'")
                            vRS1.MoveFirst()
                            For j = 0 To vRS1.RecordCount - 1
                                vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                vResultats(j).Partit = "ALTRES"
                                vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                vRS1.MoveNext()
                            Next
                        Case 3 ' PSC
                            vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='PSC'")
                            vRS1.MoveFirst()
                            For j = 0 To vRS1.RecordCount - 1
                                vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                vResultats(j).Partit = "PSC"
                                vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                vRS1.MoveNext()
                            Next
                        Case 4 ' ERC
                            vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='ERC'")
                            vRS1.MoveFirst()
                            For j = 0 To vRS1.RecordCount - 1
                                vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                vResultats(j).Partit = "ERC"
                                vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                vRS1.MoveNext()
                            Next
                        Case 5 ' IC_V
                            vPartit = vGeneralFunc.dlookup("[ID]", "PARTITS", "D.[NOM]='IC_V'")
                            vRS1.MoveFirst()
                            For j = 0 To vRS1.RecordCount - 1
                                vResultats(j).Anyo = vRS1.GFields("ANYO").Value
                                vResultats(j).Cens = vRS1.GFields("CENS_ELECTORAL").Value
                                vResultats(j).Votans = vRS1.GFields("VOTANTS").Value
                                vResultats(j).Partit = "IC_V"
                                vResultats(j).Vots = vGeneralFunc.dlookup("[VOTS]", "VOTS", "D.[CODI_COMARCA]='" & vComarca & "' AND D.[CODI_PARTIT]=" & vPartit & " AND [ANYO]=" & vRS1.GFields("ANYO").Value)
                                vRS1.MoveNext()
                            Next
                    End Select
                    For j = 0 To vRS1.RecordCount - 1
                        If vGraficFunc.Build_BarOfParties(vResultats(j), vPunt, vComarca, j) Then
                            'Cridar la formaci d'etiquetes de text del partit. Noms una vegada
                            If j = 0 Then
                                If Not vGraficFunc.Build_TextsOfParties(vPartit, vPunt, vComarca, GRAFIC_BARRES) Then
                                    strError = "Error Procedent de Procediment de construcci de Etiquetes de cada Partit"
                                    GoTo DibuixarGrafic_Exit
                                End If
                            End If
                        Else
                            strError = "Error Procedent de Procediment de construcci de Barres de cada Partit"
                            GoTo DibuixarGrafic_Exit
                        End If
                    Next
                Next i
                If Not vGraficFunc.Build_TextsOfYearInBarGrafic(vAnyosSelect, vPunt, vComarca) Then
                    strError = "Error en Procediment de construcci Etiquetes del grfic"
                End If
            Else
                strError = "Error Procedent de Procediment de construcci Textos del Grfic"
            End If
        Else
            strError = "Error Procedent de Procediment de construcci Quadre de grfic de Linies"
        End If

DibuixarGrafic_Exit:
        vXOrigen = Nothing : vYOrigen = Nothing : vMaxX = Nothing : vMaxY = Nothing
        vEscala = Nothing : vX = Nothing : vY = Nothing : vZ = Nothing
        strSQL = Nothing : vComarca = Nothing : vPartit = Nothing : i = Nothing : j = Nothing
        strError = Nothing
        vObj = Nothing : vOrigen = Nothing
        vResultats = Nothing
        vGraficFunc = Nothing
        vGeneralFunc = Nothing
        vPunt = Nothing
        GSS = Nothing
        vMV = Nothing
        vRS1 = Nothing : vRS2 = Nothing
        vComarcaPipe = Nothing
        vDB = Nothing
        vConn = Nothing
        Exit Sub

Error_DibuixarGrafic:
        'Display the error and get out
        If strError <> "" Then
            MsgBox(strError, 64)
        Else
            MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Dibuixar grfic", 64)
        End If
        'Resume Next
        Resume DibuixarGrafic_Exit
    End Sub

    Private Sub btnImportarDades_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnImportarDades.Click
        Dim vGralFunctions As New GeneralFuncions
        Dim vStrNameFile As String, vStrNameTable As String
        Dim vFileDialog As New Windows.Forms.OpenFileDialog
        If vStrPathFile <> "" Then
            vFileDialog.InitialDirectory = "c:\"
        Else
            vFileDialog.InitialDirectory = vStrPathFile
        End If
        vFileDialog.Filter = "txt files (*.txt)|*.txt"
        'vFileDialog.Filter = "txt files (*.txt)|*.txt|All files (*.*)|*.*"
        vFileDialog.FilterIndex = 2
        vFileDialog.RestoreDirectory = True
        If vFileDialog.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Try
                vStrNameFile = vFileDialog.FileName
                vStrPathFile = System.IO.Path.GetDirectoryName(vStrNameFile)
                If InStr(vStrNameFile, "Participacio") > 0 Then
                    vStrNameTable = "ParticipacioTmp"
                ElseIf InStr(vStrNameFile, "Vots") > 0 Then
                    vStrNameTable = "VotsTmp"
                End If
                If vGralFunctions.Clean_Data_Table(vStrNameTable) Then
                    If vGralFunctions.Read_Data_File(vStrNameFile, vStrNameTable) Then
                        MsgBox("Les dades de la taula " & vStrNameTable & " se han importat correctament.", MsgBoxStyle.Information, "Informaci al usuari")
                    Else
                        MsgBox("S'ha produt una errada en la importaci de les dades de la taula " & vStrNameTable & ".", MsgBoxStyle.Information, "Informaci al usuari")
                    End If
                End If
            Catch Ex As Exception
                MsgBox("Cannot read file from disk. Original error: " & Ex.Message)
            End Try
        End If
    End Sub

    Private Sub RadioButSectors_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButSectors.CheckedChanged
        If Me.RadioButSectors.Checked Or Me.RadioButBarres.Checked Then
            Me.cmbConvocatoria2.Text = ""
            Me.cmbConvocatoria2.Enabled = False
            Me.cmbPartit.Text = "TOTS"
            Me.cmbPartit.Enabled = False
        Else
            Me.cmbConvocatoria2.Enabled = True
        End If
    End Sub

    Private Sub RadioButLinies_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButLinies.CheckedChanged
        If Me.RadioButLinies.Checked Then
            Me.cmbConvocatoria2.Enabled = True
            Me.cmbPartit.Enabled = True
            Me.cmbPartit.Text = "TOTS"
        Else
            Me.cmbConvocatoria2.ValueMember = ""
            Me.cmbConvocatoria2.Enabled = False
        End If
    End Sub

    Private Sub RadioButBarres_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButBarres.CheckedChanged
        If Me.RadioButSectors.Checked Or Me.RadioButBarres.Checked Then
            Me.cmbConvocatoria2.Text = ""
            Me.cmbConvocatoria2.Enabled = False
            Me.cmbPartit.Text = "TOTS"
            Me.cmbPartit.Enabled = False
        Else
            Me.cmbConvocatoria2.Enabled = True
        End If
    End Sub


    '10. Retrieve the geometry.
    'LineGeom = GeomDig.GetGeometry
    'GeomDig = Nothing
    Sub ManipMV(ByVal ctrl As Integer, ByVal DispScale As String, ByVal ZoomFact As String, ByVal RotFact As String)
        Dim vColordialog As New System.Windows.Forms.ColorDialog()
        Dim MV As Intergraph.GeoMedia.MapviewLib.GMMapView
        MV = gobjGeoApp.ActiveWindow.Mapview
        vColordialog.AllowFullOpen = False
        ' Allows the user to get help. (The default is false.)
        vColordialog.ShowHelp = True
        ' Sets the initial color select to the current text color,
        If (vColordialog.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            MsgBox(vColordialog.Color.ToString)
            '          TextBox1.ForeColor = vColordialog.Color
        End If
        Select Case ctrl
            Case 1
                MV.BackgroundColor = RGB(vColordialog.Color.R, vColordialog.Color.G, vColordialog.Color.B)
            Case 2
                gobjGeoApp.Document.highlightColor = RGB(vColordialog.Color.R, vColordialog.Color.G, vColordialog.Color.B)
            Case 3
                gobjGeoApp.Document.selectcolor = RGB(vColordialog.Color.R, vColordialog.Color.G, vColordialog.Color.B)
            Case 4
                'If CDbl(DispScale.text) >= 1 Then
                If CDbl(DispScale) >= 1 Then
                    MV.DisplayScale = CDbl(DispScale)
                Else
                    MsgBox("Display Scale must be greater than 1. Resetting to 10000000:1")
                    MV.DisplayScale = 10000000
                    DispScale = MV.DisplayScale
                End If
            Case 5
                MV.Fit()
            Case 6
                MV.PreviousView()
            Case 7
                'MV.ZoomFactor = CDbl(ZoomFact.text)
                MV.ZoomFactor = CDbl(ZoomFact)
                MV.Zoom(False, True, 1, 1, 1, True)
            Case 8
                MV.ZoomFactor = CDbl(ZoomFact)
                MV.Zoom(True, True, 1, 1, 1, True)
            Case 9
                MV.Pan(50000.0, 0, 0)
            Case 10
                MV.Pan(-50000.0, 0, 0)
            Case 11
                MV.Pan(0, -50000.0, 0)
            Case 12
                MV.Pan(0, 50000.0, 0)
            Case 13
                MV.Rotate(CDbl(RotFact))
        End Select
        MV.Refresh()
    End Sub

    'Aquest procediment procedeix al llanament de l'esborrat de les dades
    'de grfics fets.
    Private Sub removeTableData()
        Dim errorInRemoveTable As Boolean = False
        Dim vGFunctions As New GeneralFuncions
        Dim i As Integer = 1
        On Error GoTo Error_RemoveTableData
        For i = 1 To 30
            Select Case i
                Case 1
                    vGFunctions.Clean_Data_Table("BARRESALTRES")
                Case 2
                    vGFunctions.Clean_Data_Table("BARRESCIU")
                Case 3
                    vGFunctions.Clean_Data_Table("BARRESERC")
                Case 4
                    vGFunctions.Clean_Data_Table("BARRESICV")
                Case 5
                    vGFunctions.Clean_Data_Table("BARRESPP")
                Case 6
                    vGFunctions.Clean_Data_Table("BARRESPSC")
                Case 7
                    vGFunctions.Clean_Data_Table("GRAFICBARRES")
                Case 8
                    vGFunctions.Clean_Data_Table("GRAFICLINIES")
                Case 9
                    vGFunctions.Clean_Data_Table("GRAFICSECTORS")
                Case 10
                    vGFunctions.Clean_Data_Table("LINIAALTRES")
                Case 11
                    vGFunctions.Clean_Data_Table("LINIACIU")
                Case 12
                    vGFunctions.Clean_Data_Table("LINIAERC")
                Case 13
                    vGFunctions.Clean_Data_Table("LINIAICV")
                Case 14
                    vGFunctions.Clean_Data_Table("LINIAPP")
                Case 15
                    vGFunctions.Clean_Data_Table("LINIAPSC")
                Case 16
                    vGFunctions.Clean_Data_Table("RETOLALTRES")
                Case 17
                    vGFunctions.Clean_Data_Table("RETOLCIU")
                Case 18
                    vGFunctions.Clean_Data_Table("RETOLERC")
                Case 19
                    vGFunctions.Clean_Data_Table("RETOLGRAFICSECTORS")
                Case 20
                    vGFunctions.Clean_Data_Table("RETOLICV")
                Case 21
                    vGFunctions.Clean_Data_Table("RETOLPP")
                Case 22
                    vGFunctions.Clean_Data_Table("RETOLPSC")
                Case 23
                    vGFunctions.Clean_Data_Table("RETOLSANYSBARRES")
                Case 24
                    vGFunctions.Clean_Data_Table("RETOLSLINIES")
                Case 25
                    vGFunctions.Clean_Data_Table("SECTORALTRES")
                Case 26
                    vGFunctions.Clean_Data_Table("SECTORCIU")
                Case 27
                    vGFunctions.Clean_Data_Table("SECTORERC")
                Case 28
                    vGFunctions.Clean_Data_Table("SECTORIC_V")
                Case 29
                    vGFunctions.Clean_Data_Table("SECTORPP")
                Case 30
                    vGFunctions.Clean_Data_Table("SECTORPSC")
            End Select
        Next i

RemoveTableData_Exit:
        Exit Sub

Error_RemoveTableData:
        'Display the error and get out
        errorInRemoveTable = True
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Remove Tables Data", 64)
        'Resume Next
        Resume RemoveTableData_Exit
    End Sub


    'Aquest procediment selecciona la comarca i el grafic de dades i els mostra a una escala
    'i centrat al mapview
    '@param pComarca as string, pGrafic as string
    Private Sub showComarcaAndGraphic(ByVal pComarca As String)
        On Error GoTo Error_ShowComarcaAndGraphic
        'Dimensionament de variables
        '=========================================================
        Dim vConn As vPClient.Connection
        Dim vComarcaPipe As vPClient.OriginatingPipe
        Dim vRS As GDO.GRecordset
        Dim vMV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim vPuntA As New PBasic.point, vPuntB As New PBasic.point
        Dim vGeneralFunc = New GeneralFuncions
        Dim vGraficFunc = New GraphicFunctions
        Dim vObj As Object ', vOrigen As Object
        Dim vComarca As String ', vPartit As Long, i As Integer, j As Integer
        Dim vEscala As Double, vX1 As Double, vY1 As Double, vZ1 As Double
        Dim vX2 As Double, vY2 As Double, vZ2 As Double
        Dim vXOrigen As Double, vYOrigen As Double, vMaxX As Double, vMaxY As Double
        '=========================================================
        'Actualitzem el valor de l'escala
        vComarca = vGeneralFunc.DLookup("[COMARCA]", "COMARQUES", "D.[NOM_COMAR]=""" & pComarca & """")
        vMV = gobjGeoApp.ActiveWindow.Mapview
        vEscala = vMV.DisplayScale
        vConn = gobjGeoApp.Document.Connections(1)
        vConn.CreateOriginatingPipe(vComarcaPipe)
        With vComarcaPipe
            .Table = "Comarques"
            .GeometryFieldName = "Geometry"
            .Filter = "COMARCA='" & vComarca & "'"
        End With
        vRS = vComarcaPipe.OutputRecordset
        vRS.MoveLast() : vRS.MoveFirst()
        vObj = vRS.GFields("Geometry").Value
        vGraficFunc.calculaPuntoOrigen(vObj, vComarca, vX1, vY1, vXOrigen, vYOrigen, vMaxX, vMaxY)
        vPuntA.X = vXOrigen : vPuntA.Y = vYOrigen : vPuntA.Z = 0.0#
        vPuntB.X = vMaxX + AMPLADA_GRAFIC
        If vMaxY > vYOrigen + ALTURA_DATOS_EN_GRAFIC Then
            vPuntB.Y = vMaxY
        Else
            vPuntB.Y = vYOrigen + ALTURA_DATOS_EN_GRAFIC
        End If
        With vMV
            .ZoomArea(vPuntA.X, vPuntA.Y, vPuntA.Z, vPuntB.X, vPuntB.Y, vPuntB.Z)
            vEscala = ESCALA_PER_A_GRAFICS
            vMV.DisplayScale = vEscala
        End With

ShowComarcaAndGraphic_Exit:
        vXOrigen = Nothing : vYOrigen = Nothing : vMaxX = Nothing : vMaxY = Nothing
        vEscala = Nothing : vX1 = Nothing : vY1 = Nothing : vZ1 = Nothing
        vX2 = Nothing : vY2 = Nothing : vZ2 = Nothing
        vComarca = Nothing
        vObj = Nothing
        vGraficFunc = Nothing
        vGeneralFunc = Nothing
        vPuntA = Nothing
        vPuntB = Nothing
        vMV = Nothing
        vRS = Nothing
        vComarcaPipe = Nothing
        vConn = Nothing
        Exit Sub

Error_ShowComarcaAndGraphic:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Dibuixar grfic", 64)
        'Resume Next
        Resume ShowComarcaAndGraphic_Exit
    End Sub

    Private Sub BtnIncorporaDades_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnIncorporaDades.Click
        On Error GoTo Error_IncorporaDades
        Dim vConn As vPClient.Connection
        Dim vDB As GDO.GDatabase
        Dim vResultat As GDO.GRecordset
        Dim strSQL As String, strError As String
        Dim vGFunctions As New GeneralFuncions
        Dim vAnyoP As Integer, vAnyoV As Integer
        Dim vIncorporacioCorrecta As Boolean = True
        '=========================================================
        If vGFunctions.DCount("*", "ParticipacioTmp", "") <> 41 Then
            MsgBox("El nombre de registres de la taula [ParticipacioTmp]" & vbCrLf & _
                "Debe ser 41: un per cada comarca. Comproveu-ho", MsgBoxStyle.Information, "Informaci al usuari")
            GoTo IncorporaDades_Exit
        ElseIf vGFunctions.DCount("*", "VotsTmp", "") <> 246 Then
            MsgBox("El nombre de registres de la taula [VotsTmp]" & vbCrLf & _
                "Debe ser 246: six per cada comarca. Comproveu-ho" & vbCrLf & _
                "Corresponents a cadascuna de les six candidatures.", MsgBoxStyle.Information, "Informaci al usuari")
            GoTo IncorporaDades_Exit
        End If
        vConn = gobjGeoApp.Document.Connections(1)
        vDB = vConn.Database
        'Mirem l'exercici a que corresponen les dades de Participaci
        strSQL = "SELECT DISTINCT P.ANYO FROM PARTICIPACIOTMP P ORDER BY P.ANYO;"
        vResultat = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
        If Not vResultat.EOF And Not vResultat.BOF Then
            vResultat.MoveLast() : vResultat.MoveFirst()
            If vResultat.RecordCount > 1 Then
                MsgBox("A la taula ParticipaciTMP hi ha ms d'un exercici" & vbCrLf & _
                    "Debe corregir-se esta anomala", MsgBoxStyle.Information, "Informaci al usuari")
                GoTo IncorporaDades_Exit
            Else
                vAnyoP = vResultat.GFields("ANYO").Value
            End If
        End If
        'Mirem l'exercici a que corresponen les dades de Vots
        strSQL = "SELECT DISTINCT V.ANYO FROM VOTSTMP V ORDER BY V.ANYO;"
        vResultat = vDB.OpenRecordset(strSQL, GDO.GConstants.gdbOpenDynaset)
        If Not vResultat.EOF And Not vResultat.BOF Then
            vResultat.MoveLast() : vResultat.MoveFirst()
            If vResultat.RecordCount > 1 Then
                MsgBox("A la taula VotsTMP hi ha ms d'un exercici" & vbCrLf & _
                    "Debe corregir-se esta anomala", MsgBoxStyle.Information, "Informaci al usuari")
                GoTo IncorporaDades_Exit
            Else
                vAnyoV = vResultat.GFields("ANYO").Value
            End If
        End If
        'Comproven que tots dos anys sn iguals
        If vAnyoP <> vAnyoV Then
            MsgBox("Les convocatries a que responen les dades de les taules ParticipacioTMP" & vbCrLf & _
            "i VotsTMP sn diferents. S'han de corregir les dades abans de incorporarles", MsgBoxStyle.Information, "Informaci al usuari")
            GoTo IncorporaDades_Exit
        End If
        If vGFunctions.DCount("*", "Participacio", "D.[ANYO]=" & vAnyoP) > 0 And vGFunctions.DCount("*", "Vots", "D.[ANYO]=" & vAnyoV) > 0 Then
            'Existeixen a totes dues taules. Es pregunta per a substituir
            If MsgBox("De l'exercidi " & vAnyoP & " ja existeixen dades a ambdues taules" & vbCrLf & _
            "Si pren [SI] s'esborrarant les dades velles i " & vbCrLf & _
            "es substituiran per les noves", MsgBoxStyle.Information Or MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton2, "Informaci al usuari") = MsgBoxResult.Yes Then
                'Esborrar dades participaci
                If Not vGFunctions.Clean_Data_Table("Participacio", vAnyoP) Then
                    strError = "S'ha produt un error al esborrar dades da la taula Participacio"
                End If
                'Esborrar dades Vots
                If Not vGFunctions.Clean_Data_Table("Vots", vAnyoV) Then
                    strError = "S'ha produt un error al esborrar dades da la taula Vots"
                End If
                'Afegir dades participacio
                If Not vGFunctions.Load_Data_Tmp("ParticipacioTMP", "Participacio") Then
                    strError = "S'ha produt un error al guardar les dades de la taula Participacio"
                End If
                'Afegir dades vots
                If Not vGFunctions.Load_Data_Tmp("VotsTMP", "Vots") Then
                    strError = "S'ha produt un error al guardar les dades de la taula Vots"
                End If
            Else
                GoTo IncorporaDades_Exit
            End If
        ElseIf vGFunctions.DCount("*", "Participacio", "D.[ANYO]=" & vAnyoP) > 0 And vGFunctions.DCount("*", "Vots", "D.[ANYO]=" & vAnyoV) = 0 Then
            'Existeixen a Participaci i no a Vots. Es pregunta per a substituir
            If MsgBox("A la taula Participci ja existeixen dades de " & vAnyoP & vbCrLf & _
            "Si pren [SI] s'esborraran les dades velles i " & vbCrLf & _
            "es substituiran per les noves", MsgBoxStyle.Information Or MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton2, "Informaci al usuari") = MsgBoxResult.Yes Then
                'Esborrar dades participaci
                If Not vGFunctions.Clean_Data_Table("Participacio", vAnyoP) Then
                    strError = "S'ha produt un error al esborrar dades da la taula Participacio"
                End If
                'Afegir dades participacio
                If Not vGFunctions.Load_Data_Tmp("ParticipacioTMP", "Participacio") Then
                    strError = "S'ha produt un error al guardar les dades de la taula Participacio"
                End If
                'Afegir dades vots
                If Not vGFunctions.Load_Data_Tmp("VotsTMP", "Vots") Then
                    strError = "S'ha produt un error al guardar les dades de la taula Vots"
                End If
            Else
                GoTo IncorporaDades_Exit
            End If
        ElseIf vGFunctions.DCount("*", "Participacio", "D.[ANYO]=" & vAnyoP) = 0 And vGFunctions.DCount("*", "Vots", "D.[ANYO]=" & vAnyoV) > 0 Then
            'No Existeixen a Participacin i Si a Vots. Es pregunta per a substituir
            If MsgBox("A la taula Vots ja existeixen dades de l'any " & vAnyoV & vbCrLf & _
            "Si pren [SI] s'esborraran les dades velles i " & vbCrLf & _
            "es substituiran per les noves", MsgBoxStyle.Information Or MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton2, "Informaci al usuari") = MsgBoxResult.Yes Then
                'Esborrar dades participaci
                If Not vGFunctions.Clean_Data_Table("Participacio", vAnyoP) Then
                    strError = "S'ha produt un error al esborrar dades da la taula Participacio"
                End If
                'Afegir dades participacio
                If Not vGFunctions.Load_Data_Tmp("ParticipacioTMP", "Participacio") Then
                    strError = "S'ha produt un error al guardar les dades de la taula Participacio"
                End If
                'Afegir dades vots
                If Not vGFunctions.Load_Data_Tmp("VotsTMP", "Vots") Then
                    strError = "S'ha produt un error al guardar les dades de la taula Vots"
                End If
            Else
                GoTo IncorporaDades_Exit
            End If
        ElseIf vGFunctions.DCount("*", "Participacio", "D.[ANYO]=" & vAnyoP) = 0 And vGFunctions.DCount("*", "Vots", "D.[ANYO]=" & vAnyoV) = 0 Then
            'Afegir dades participacio
            If Not vGFunctions.Load_Data_Tmp("ParticipacioTMP", "Participacio") Then
                strError = "S'ha produt un error al guardar les dades de la taula Participacio"
            End If
            'Afegir dades vots
            If Not vGFunctions.Load_Data_Tmp("VotsTMP", "Vots") Then
                strError = "S'ha produt un error al guardar les dades de la taula Vots"
            End If
        End If
        'Finalment si la incorporaci ha estat correcta s'esborren les dades temporals
        If Not vGFunctions.Clean_Data_Table("ParticipacioTMP") Then
            strError = "S'ha produt un error al esborrar dades da la taula ParticipacioTMP"
        Else
            If Not vGFunctions.Clean_Data_Table("VotsTMP") Then
                strError = "S'ha produt un error al esborrar dades da la taula VotsTMP"
            End If
        End If

IncorporaDades_Exit:
        If strError <> "" Then
            MsgBox(strError, MsgBoxStyle.Information, "Informaci d'Errors")
            vIncorporacioCorrecta = False
        End If
        vConn = Nothing
        vDB = Nothing
        vResultat = Nothing
        strSQL = Nothing
        strError = Nothing
        Exit Sub

Error_IncorporaDades:
        'Display the error and get out
        vIncorporacioCorrecta = False
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Dibuixar grfic", 64)
        'Resume Next
        Resume IncorporaDades_Exit
    End Sub

    'Aquest procediment mostra el mapa amb totes les comarques i el seu nom.
    'Esborra les entitats grfiques que hi hagi i el torna a presentar sencer
    '@param pComarca as string, pGrafic as string
    Private Sub showWholeMap()
        On Error GoTo Error_ShowWholeMap
        'Dimensionament de variables
        '=========================================================
        Dim vMV As Intergraph.GeoMedia.MapviewLib.GMMapView
        Dim vGFunctions As New GeneralFuncions
        '=========================================================
        'Actualitzem el valor de l'escala
        vMV = gobjGeoApp.ActiveWindow.Mapview
        'vEscala = vMV.DisplayScale
        'Eliminar llegendes sobreres
        If vGFunctions.Clean_Legend_Entries() = False Then
            GoTo ShowWholeMap_Exit
        End If
        'Eliminar dades de la Base de dades
        removeTableData()
        'Posar el mapa amb el tamany adequat
        vMV.Fit()

ShowWholeMap_Exit:
        vGFunctions = Nothing
        vMV = Nothing
        Exit Sub

Error_ShowWholeMap:
        'Display the error and get out
        MsgBox("Error (" & Err.Number & "): " & Err.Description & " en Dibuixar grfic", 64)
        'Resume Next
        Resume ShowWholeMap_Exit
    End Sub


    Private Sub TancarFormulari()
        Dim msg As String
        Dim title As String
        Dim style As MsgBoxStyle
        Dim response As MsgBoxResult
        Dim myChartsData As New CHARTSDATA
        style = MsgBoxStyle.Question Or MsgBoxStyle.YesNo Or MsgBoxStyle.DefaultButton2
        title = "Tancar el formulari?"
        msg = "Si desitja Tornar a deixar el mapa sense" & vbCrLf
        msg = msg & "grfics premi [SI]." & vbCrLf
        msg = msg & "Si prem [NO]. Quedar el mapa i grfic tal" & vbCrLf
        msg = msg & "com est ara i noms tancar el formulari."
        title = "Esborrar Grafic al tancar"
        response = MsgBox(msg, style, title)
        If response = MsgBoxResult.Yes Then
            showWholeMap()
        End If
        Me.Close()
        GC.Collect()
        GC.WaitForPendingFinalizers()
    End Sub

    Private Sub frmCHARTSDATA_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        TancarFormulari()
    End Sub
End Class






